      SUBROUTINE AFG7P(NM,N,LOW,IGH,AR,AI,ORTR,ORTI)
         INTEGER IGH,LOW,N,NM
         DOUBLE PRECISION AI,AR,ORTI,ORTR
         DIMENSION AI(NM,N),AR(NM,N),ORTI(IGH),ORTR(IGH)
         INTEGER I,II,J,JJ,KP1,LA,M,MP
         DOUBLE PRECISION F,FI,FR,G,H,SCALE,SYS056
         DATA SYS056/5.56268464627D-308/
       LA = IGH - 1
       KP1 = LOW + 1
       IF (LA .LT. KP1) GO TO 140
          DO 130 M = KP1, LA
             H = 0.0D0
             ORTR(M) = 0.0D0
             ORTI(M) = 0.0D0
             SCALE = 0.0D0
C HOPMPOBKA CTOA
             DO 10 I = M, IGH
                SCALE = SCALE + DABS(AR(I,M-1)) + DABS(AI(I,M-1))
   10        CONTINUE
             IF (SCALE .GT. SYS056) GO TO 30
                DO 20 I = M, IGH
                   AR(I,M-1) = 0.D0
                   AI(I,M-1) = 0.D0
   20           CONTINUE
                GO TO 130
   30     CONTINUE
          MP = M + IGH
          F = 1.D0/SCALE
C  I = IGH,M,-1
          DO 40 II = M, IGH
             I = MP - II
             ORTR(I) = AR(I,M-1)*F
             ORTI(I) = AI(I,M-1)*F
             H = H + ORTR(I)*ORTR(I) + ORTI(I)*ORTI(I)
   40     CONTINUE
          G = DSQRT(H)
          F = DMAX1(DABS(ORTR(M)),DABS(ORTI(M)))
          IF (F .LE. SYS056) GO TO 50
             FR = ORTR(M)/F
             FI = ORTI(M)/F
             F = DSQRT(FR*FR+FI*FI)*F
             H = H + F*G
             G = G/F
             ORTR(M) = (1.0D0 + G)*ORTR(M)
             ORTI(M) = (1.0D0 + G)*ORTI(M)
             GO TO 60
   50     CONTINUE
          ORTR(M) = G
          ORTI(M) = 0.0D0
          AI(M,M-1) = 0.0D0
          AR(M,M-1) = SCALE
C OPM-E (I-(U*UH)/H)*A
   60     CONTINUE
          DO 90 J = M, N
             FR = 0.0D0
             FI = 0.0D0
C  I = IGH,M,-1
             DO 70 II = M, IGH
                I = MP - II
                FR = FR + ORTR(I)*AR(I,J) + ORTI(I)*AI(I,J)
                FI = FI + ORTR(I)*AI(I,J) - ORTI(I)*AR(I,J)
   70        CONTINUE
             FR = FR/H
             FI = FI/H
             DO 80 I = M, IGH
                AR(I,J) = AR(I,J) - FR*ORTR(I) + FI*ORTI(I)
                AI(I,J) = AI(I,J) - FR*ORTI(I) - FI*ORTR(I)
   80        CONTINUE
   90     CONTINUE
C  OPM-E (I-(U*UH)/H)*A*(I-(U*UH)/H)
          DO 120 I = 1, IGH
             FR = 0.0D0
             FI = 0.0D0
C  J = IGH,M,-1
             DO 100 JJ = M, IGH
                J = MP - JJ
                FR = FR + ORTR(J)*AR(I,J) - ORTI(J)*AI(I,J)
                FI = FI + ORTR(J)*AI(I,J) + ORTI(J)*AR(I,J)
  100        CONTINUE
             FR = FR/H
             FI = FI/H
             DO 110 J = M, IGH
                AR(I,J) = AR(I,J) - FR*ORTR(J) - FI*ORTI(J)
                AI(I,J) = AI(I,J) + FR*ORTI(J) - FI*ORTR(J)
  110        CONTINUE
  120     CONTINUE
          ORTR(M) = SCALE*ORTR(M)
          ORTI(M) = SCALE*ORTI(M)
          AR(M,M-1) = -G*AR(M,M-1)
          AI(M,M-1) = -G*AI(M,M-1)
  130  CONTINUE
  140  RETURN
      END
